OpenShot Audio Library | OpenShotAudio: juce::Time Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.1

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
juce::Time Class Reference

`#include <juce_Time.h>`

## Public Member Functions
| Time ()=default
| Time (int64 millisecondsSinceEpoch) noexcept
| Time (int year, int month, int day, int hours, int minutes, int seconds=0, int milliseconds=0, bool useLocalTime=true) noexcept
| Time (const Time &)=default
Time & | operator= (const Time &)=default
int64 | toMilliseconds () const noexcept
int | getYear () const noexcept
int | getMonth () const noexcept
String | getMonthName (bool threeLetterVersion) const
int | getDayOfMonth () const noexcept
int | getDayOfWeek () const noexcept
int | getDayOfYear () const noexcept
String | getWeekdayName (bool threeLetterVersion) const
int | getHours () const noexcept
bool | isAfternoon () const noexcept
int | getHoursInAmPmFormat () const noexcept
int | getMinutes () const noexcept
int | getSeconds () const noexcept
int | getMilliseconds () const noexcept
bool | isDaylightSavingTime () const noexcept
String | getTimeZone () const
int | getUTCOffsetSeconds () const noexcept
String | getUTCOffsetString (bool includeDividerCharacters) const
String | toString (bool includeDate, bool includeTime, bool includeSeconds=true, bool use24HourClock=false) const
String | formatted (const String &format) const
String | toISO8601 (bool includeDividerCharacters) const
Time & | operator+= (RelativeTime delta) noexcept
Time & | operator-= (RelativeTime delta) noexcept
bool | setSystemTimeToThisTime () const

## Static Public Member Functions
static Time JUCE_CALLTYPE | getCurrentTime () noexcept
static Time | fromISO8601 (StringRef iso8601)
static String | getWeekdayName (int dayNumber, bool threeLetterVersion)
static String | getMonthName (int monthNumber, bool threeLetterVersion)
static int64 | currentTimeMillis () noexcept
static uint32 | getMillisecondCounter () noexcept
static double | getMillisecondCounterHiRes () noexcept
static void | waitForMillisecondCounter (uint32 targetTime) noexcept
static uint32 | getApproximateMillisecondCounter () noexcept
static int64 | getHighResolutionTicks () noexcept
static int64 | getHighResolutionTicksPerSecond () noexcept
static double | highResolutionTicksToSeconds (int64 ticks) noexcept
static int64 | secondsToHighResolutionTicks (double seconds) noexcept
static Time | getCompilationDate ()

## Detailed Description

Holds an absolute date and time.

Internally, the time is stored at millisecond precision.

See also
  RelativeTime

Definition at line 36 of file juce_Time.h.

## Constructor & Destructor Documentation

## ◆ Time() [1/3]

juce::Time::Time | ( |  | ) |
| default

Creates a Time object. This default constructor creates a time of midnight Jan 1st 1970 UTC, (which is represented internally as 0ms). To create a time object representing the current time, use getCurrentTime().

See also
  getCurrentTime

Referenced by fromISO8601(), getCompilationDate(), and getCurrentTime().

## ◆ Time() [2/3]

juce::Time::Time | ( | int64 | millisecondsSinceEpoch | ) |
| explicitnoexcept

Creates a time based on a number of milliseconds. To create a time object set to the current time, use getCurrentTime().

Parameters

  millisecondsSinceEpoch | the number of milliseconds since the unix 'epoch' (midnight Jan 1st 1970 UTC).

See also
  getCurrentTime, currentTimeMillis

Definition at line 184 of file juce_Time.cpp.

## ◆ Time() [3/3]

juce::Time::Time | ( | int | year,
|  | int | month,
|  | int | day,
|  | int | hours,
|  | int | minutes,
|  | int | seconds = `0`,
|  | int | milliseconds = `0`,
|  | bool | useLocalTime = `true`
| ) |  |
| noexcept

Creates a time from a set of date components.

Parameters

  year | the year, in 4-digit format, e.g. 2004
  month | the month, in the range 0 to 11
  day | the day of the month, in the range 1 to 31
  hours | hours in 24-hour clock format, 0 to 23
  minutes | minutes 0 to 59
  seconds | seconds 0 to 59
  milliseconds | milliseconds 0 to 999
  useLocalTime | if true, assume input is in this machine's local timezone if false, assume input is in UTC.

Definition at line 186 of file juce_Time.cpp.

## Member Function Documentation

## ◆ currentTimeMillis()

int64 juce::Time::currentTimeMillis | ( |  | ) |
| staticnoexcept

Returns the current system time.

Returns the number of milliseconds since midnight Jan 1st 1970 UTC.

Should be accurate to within a few millisecs, depending on platform, hardware, etc.

Definition at line 205 of file juce_Time.cpp.

Referenced by getCurrentTime(), and juce::Random::setSeedRandomly().

## ◆ formatted()

String juce::Time::formatted | ( | const String & | format | ) | const

Converts this date/time to a string with a user-defined format.

This uses the C strftime() function to format this time as a string. To save you looking it up, these are the escape codes that strftime uses (other codes might work on some platforms and not others, but these are the common ones):

- a is replaced by the locale's abbreviated weekday name.
- A is replaced by the locale's full weekday name.
- b is replaced by the locale's abbreviated month name.
- B is replaced by the locale's full month name.
- c is replaced by the locale's appropriate date and time representation.
- d is replaced by the day of the month as a decimal number [01,31].
- H is replaced by the hour (24-hour clock) as a decimal number [00,23].
- I is replaced by the hour (12-hour clock) as a decimal number [01,12].
- j is replaced by the day of the year as a decimal number [001,366].
- m is replaced by the month as a decimal number [01,12].
- M is replaced by the minute as a decimal number [00,59].
- p is replaced by the locale's equivalent of either a.m. or p.m.
- S is replaced by the second as a decimal number [00,60].
- U is replaced by the week number of the year (Sunday as the first day of the week) as a decimal number [00,53].
- w is replaced by the weekday as a decimal number [0,6], with 0 representing Sunday.
- W is replaced by the week number of the year (Monday as the first day of the week) as a decimal number [00,53]. All days in a new year preceding the first Monday are considered to be in week 0.
- x is replaced by the locale's appropriate date representation.
- X is replaced by the locale's appropriate time representation.
- y is replaced by the year without century as a decimal number [00,99].
- Y is replaced by the year with century as a decimal number.
- Z is replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists.
- %% is replaced by %.

See also
  toString

Definition at line 326 of file juce_Time.cpp.

Referenced by juce::WavAudioFormat::createBWAVMetadata().

## ◆ fromISO8601()

Time juce::Time::fromISO8601 | ( | StringRef | iso8601 | ) |
| static

Parses an ISO-8601 string and returns it as a Time.

Definition at line 456 of file juce_Time.cpp.

## ◆ getApproximateMillisecondCounter()

uint32 juce::Time::getApproximateMillisecondCounter | ( |  | ) |
| staticnoexcept

Less-accurate but faster version of getMillisecondCounter().

This will return the last value that getMillisecondCounter() returned, so doesn't need to make a system call, but is less accurate - it shouldn't be more than 100ms away from the correct time, though, so is still accurate enough for a lot of purposes.

See also
  getMillisecondCounter

Definition at line 246 of file juce_Time.cpp.

Referenced by juce::StringPool::garbageCollect().

## ◆ getCompilationDate()

Time juce::Time::getCompilationDate | ( |  | ) |
| static

Returns a Time based on the value of the DATE macro when this module was compiled

Definition at line 591 of file juce_Time.cpp.

## ◆ getCurrentTime()

Time JUCE_CALLTYPE juce::Time::getCurrentTime | ( |  | ) |
| staticnoexcept

Returns a Time object that is set to the current system time.

This may not be monotonic, as the system time can change at any moment. You should therefore not use this method for measuring time intervals.

See also
  currentTimeMillis

Definition at line 218 of file juce_Time.cpp.

Referenced by juce::TimeSliceThread::addTimeSliceClient(), juce::FileLogger::createDateStampedLogger(), juce::FileLogger::FileLogger(), juce::UndoManager::getTimeOfRedoTransaction(), juce::TimeSliceThread::moveToFrontOfQueue(), juce::PerformanceCounter::PerformanceCounter(), and juce::TimeSliceThread::run().

## ◆ getDayOfMonth()

int juce::Time::getDayOfMonth | ( |  | ) | const
| noexcept

Returns the day of the month (in this machine's local timezone). The value returned is in the range 1 to 31.

Definition at line 336 of file juce_Time.cpp.

Referenced by toISO8601(), and toString().

## ◆ getDayOfWeek()

int juce::Time::getDayOfWeek | ( |  | ) | const
| noexcept

Returns the number of the day of the week (in this machine's local timezone). The value returned is in the range 0 to 6 (0 = sunday, 1 = monday, etc).

Definition at line 337 of file juce_Time.cpp.

Referenced by getWeekdayName().

## ◆ getDayOfYear()

int juce::Time::getDayOfYear | ( |  | ) | const
| noexcept

Returns the number of the day of the year (in this machine's local timezone). The value returned is in the range 0 to 365.

Definition at line 335 of file juce_Time.cpp.

## ◆ getHighResolutionTicks()

static int64 juce::Time::getHighResolutionTicks | ( |  | ) |
| staticnoexcept

Returns the current high-resolution counter's tick-count.

This is a similar idea to getMillisecondCounter(), but with a higher resolution.

See also
  getHighResolutionTicksPerSecond, highResolutionTicksToSeconds, secondsToHighResolutionTicks

Referenced by juce::Random::setSeedRandomly(), juce::PerformanceCounter::start(), and juce::PerformanceCounter::stop().

## ◆ getHighResolutionTicksPerSecond()

static int64 juce::Time::getHighResolutionTicksPerSecond | ( |  | ) |
| staticnoexcept

Returns the resolution of the high-resolution counter in ticks per second.

See also
  getHighResolutionTicks, highResolutionTicksToSeconds, secondsToHighResolutionTicks

Referenced by juce::Random::setSeedRandomly().

## ◆ getHours()

int juce::Time::getHours | ( |  | ) | const
| noexcept

Returns the number of hours since midnight (in this machine's local timezone). This is in 24-hour clock format, in the range 0 to 23.

See also
  getHoursInAmPmFormat, isAfternoon

Definition at line 338 of file juce_Time.cpp.

Referenced by getHoursInAmPmFormat(), isAfternoon(), toISO8601(), and toString().

## ◆ getHoursInAmPmFormat()

int juce::Time::getHoursInAmPmFormat | ( |  | ) | const
| noexcept

Returns the hours in 12-hour clock format (in this machine's local timezone). This will return a value 1 to 12 - use isAfternoon() to find out whether this is in the afternoon or morning.

See also
  getHours, isAfternoon

Definition at line 343 of file juce_Time.cpp.

Referenced by toString().

## ◆ getMillisecondCounter()

uint32 juce::Time::getMillisecondCounter | ( |  | ) |
| staticnoexcept

Returns the number of millisecs since a fixed event (usually system startup).

This returns a monotonically increasing value which is unaffected by changes to the system clock. It should be accurate to within a few millisecs, depending on platform, hardware, etc.

Being a 32-bit return value, it will of course wrap back to 0 after 2^32 seconds of uptime, so be careful to take that into account. If you need a 64-bit time, you can use currentTimeMillis() instead.

See also
  getApproximateMillisecondCounter

Definition at line 226 of file juce_Time.cpp.

Referenced by getApproximateMillisecondCounter(), juce::MidiKeyboardState::noteOff(), juce::MidiKeyboardState::noteOn(), juce::BufferingAudioReader::readSamples(), juce::ThreadPool::removeAllJobs(), juce::Random::setSeedRandomly(), juce::ThreadPool::waitForJobToFinish(), juce::BufferingAudioSource::waitForNextAudioBlockReady(), juce::ChildProcess::waitForProcessToFinish(), and juce::Thread::waitForThreadToExit().

## ◆ getMillisecondCounterHiRes()

static double juce::Time::getMillisecondCounterHiRes | ( |  | ) |
| staticnoexcept

Returns the number of millisecs since a fixed event (usually system startup).

This has the same function as getMillisecondCounter(), but returns a more accurate value, using a higher-resolution timer if one is available.

See also
  getMillisecondCounter

Referenced by juce::MidiMessageCollector::handleNoteOff(), juce::MidiMessageCollector::handleNoteOn(), juce::MidiMessageCollector::removeNextBlockOfMessages(), and juce::MidiMessageCollector::reset().

## ◆ getMilliseconds()

int juce::Time::getMilliseconds | ( |  | ) | const
| noexcept

Returns the number of milliseconds, 0 to 999.

Unlike toMilliseconds(), this just returns the position within the current second rather than the total number since the epoch.

See also
  toMilliseconds

Definition at line 341 of file juce_Time.cpp.

Referenced by toISO8601().

## ◆ getMinutes()

int juce::Time::getMinutes | ( |  | ) | const
| noexcept

Returns the number of minutes, 0 to 59 (in this machine's local timezone).

Definition at line 339 of file juce_Time.cpp.

Referenced by toISO8601(), and toString().

## ◆ getMonth()

int juce::Time::getMonth | ( |  | ) | const
| noexcept

Returns the number of the month (in this machine's local timezone). The value returned is in the range 0 to 11.

See also
  getMonthName

Definition at line 334 of file juce_Time.cpp.

Referenced by getMonthName(), and toISO8601().

## ◆ getMonthName() [1/2]

String juce::Time::getMonthName | ( | bool | threeLetterVersion | ) | const

Returns the name of the month (in this machine's local timezone).

Parameters

  threeLetterVersion | if true, it'll be a 3-letter abbreviation, e.g. "Jan"; if false it'll return the long form, e.g. "January"

See also
  getMonth

Definition at line 531 of file juce_Time.cpp.

Referenced by getMonthName(), and toString().

## ◆ getMonthName() [2/2]

String juce::Time::getMonthName | ( | int | monthNumber,
|  | bool | threeLetterVersion
| ) |  |
| static

Returns the name of one of the months.

Parameters

  monthNumber | the month, 0 to 11
  threeLetterVersion | if true, it'll be a 3-letter abbreviation, e.g. "Jan"; if false it'll return the long form, e.g. "January"

Definition at line 544 of file juce_Time.cpp.

## ◆ getSeconds()

int juce::Time::getSeconds | ( |  | ) | const
| noexcept

Returns the number of seconds, 0 to 59.

Definition at line 340 of file juce_Time.cpp.

Referenced by toISO8601(), and toString().

## ◆ getTimeZone()

String juce::Time::getTimeZone | ( |  | ) | const

Returns a 3-character string to indicate the local timezone.

Definition at line 363 of file juce_Time.cpp.

## ◆ getUTCOffsetSeconds()

int juce::Time::getUTCOffsetSeconds | ( |  | ) | const
| noexcept

Returns the local timezone offset from UTC in seconds.

Definition at line 402 of file juce_Time.cpp.

Referenced by getUTCOffsetString().

## ◆ getUTCOffsetString()

String juce::Time::getUTCOffsetString | ( | bool | includeDividerCharacters | ) | const

Returns a string to indicate the offset of the local timezone from UTC.

Returns
  "+XX:XX", "-XX:XX" or "Z"

Parameters

  includeDividerCharacters | whether to include or omit the ":" divider in the string

Definition at line 407 of file juce_Time.cpp.

Referenced by toISO8601().

## ◆ getWeekdayName() [1/2]

String juce::Time::getWeekdayName | ( | bool | threeLetterVersion | ) | const

Returns the name of the weekday (in this machine's local timezone).

Parameters

  threeLetterVersion | if true, it'll return a 3-letter abbreviation, e.g. "Tue"; if false, it'll return the full version, e.g. "Tuesday".

Definition at line 536 of file juce_Time.cpp.

Referenced by getWeekdayName().

## ◆ getWeekdayName() [2/2]

String juce::Time::getWeekdayName | ( | int | dayNumber,
|  | bool | threeLetterVersion
| ) |  |
| static

Returns the name of a day of the week.

Parameters

  dayNumber | the day, 0 to 6 (0 = sunday, 1 = monday, etc)
  threeLetterVersion | if true, it'll return a 3-letter abbreviation, e.g. "Tue"; if false, it'll return the full version, e.g. "Tuesday".

Definition at line 552 of file juce_Time.cpp.

## ◆ getYear()

int juce::Time::getYear | ( |  | ) | const
| noexcept

Returns the year (in this machine's local timezone). A 4-digit format is used, e.g. 2004.

Definition at line 333 of file juce_Time.cpp.

Referenced by toISO8601(), and toString().

## ◆ highResolutionTicksToSeconds()

double juce::Time::highResolutionTicksToSeconds | ( | int64 | ticks | ) |
| staticnoexcept

Converts a number of high-resolution ticks into seconds.

See also
  getHighResolutionTicks, getHighResolutionTicksPerSecond, secondsToHighResolutionTicks

Definition at line 278 of file juce_Time.cpp.

Referenced by juce::PerformanceCounter::stop().

## ◆ isAfternoon()

bool juce::Time::isAfternoon | ( |  | ) | const
| noexcept

Returns true if the time is in the afternoon (in this machine's local timezone).

Returns
  true for "PM", false for "AM".

See also
  getHoursInAmPmFormat, getHours

Definition at line 353 of file juce_Time.cpp.

Referenced by toString().

## ◆ isDaylightSavingTime()

bool juce::Time::isDaylightSavingTime | ( |  | ) | const
| noexcept

Returns true if the local timezone uses a daylight saving correction.

Definition at line 358 of file juce_Time.cpp.

Referenced by getTimeZone().

## ◆ operator+=()

Time & juce::Time::operator+= | ( | RelativeTime | delta | ) |
| noexcept

Adds a RelativeTime to this time.

Definition at line 564 of file juce_Time.cpp.

## ◆ operator-=()

Time & juce::Time::operator-= | ( | RelativeTime | delta | ) |
| noexcept

Subtracts a RelativeTime from this time.

Definition at line 565 of file juce_Time.cpp.

## ◆ secondsToHighResolutionTicks()

int64 juce::Time::secondsToHighResolutionTicks | ( | double | seconds | ) |
| staticnoexcept

Converts a number seconds into high-resolution ticks.

See also
  getHighResolutionTicks, getHighResolutionTicksPerSecond, highResolutionTicksToSeconds

Definition at line 283 of file juce_Time.cpp.

## ◆ setSystemTimeToThisTime()

bool juce::Time::setSystemTimeToThisTime | ( |  | ) | const

Tries to set the computer's clock.

Returns
  true if this succeeds, although depending on the system, the application might not have sufficient privileges to do this.

## ◆ toISO8601()

String juce::Time::toISO8601 | ( | bool | includeDividerCharacters | ) | const

Returns a fully described string of this date and time in ISO-8601 format (using the local timezone).

Parameters

  includeDividerCharacters | whether to include or omit the "-" and ":" dividers in the string

Definition at line 422 of file juce_Time.cpp.

## ◆ toMilliseconds()

int64 juce::Time::toMilliseconds | ( |  | ) | const
| inlinenoexcept

Returns the time as a number of milliseconds.

Returns
  the number of milliseconds this Time object represents, since midnight Jan 1st 1970 UTC.

See also
  getMilliseconds

Definition at line 98 of file juce_Time.h.

Referenced by juce::FileInputSource::hashCode(), juce::File::setCreationTime(), juce::File::setLastAccessTime(), and juce::File::setLastModificationTime().

## ◆ toString()

String juce::Time::toString | ( | bool | includeDate,
|  | bool | includeTime,
|  | bool | includeSeconds = `true`,
|  | bool | use24HourClock = `false`
| ) |  | const

Returns a string version of this date and time, using this machine's local timezone.

For a more powerful way of formatting the date and time, see the formatted() method.

Parameters

  includeDate | whether to include the date in the string
  includeTime | whether to include the time in the string
  includeSeconds | if the time is being included, this provides an option not to include the seconds in it
  use24HourClock | if the time is being included, sets whether to use am/pm or 24 hour notation.

See also
  formatted

Definition at line 289 of file juce_Time.cpp.

Referenced by juce::FileLogger::FileLogger().

## ◆ waitForMillisecondCounter()

void juce::Time::waitForMillisecondCounter | ( | uint32 | targetTime | ) |
| staticnoexcept

Waits until the getMillisecondCounter() reaches a given value.

This will make the thread sleep as efficiently as it can while it's waiting.

Definition at line 252 of file juce_Time.cpp.

The documentation for this class was generated from the following files:

- juce_Time.h
- juce_Time.cpp